# Gst::Task Class Reference

Gst::Task - Abstraction of GStreamer streaming threads. More...

`#include <task.h>`

Inheritance diagram for Gst::Task:

List of all members.

## Public Types
typedef sigc::slot<void> | SlotTask
| For example, void on_do_task();.
## Public Member Functions
virtual | ~Task ()
GstTask* | gobj ()
| Provides access to the underlying C GObject.
const GstTask* | gobj () const
| Provides access to the underlying C GObject.
GstTask* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
TaskState | get_state () const
| Get the current state of the task.
bool | join ()
| Joins task.
bool | pause ()
| Pauses task.
void | set_lock (Glib::StaticRecMutex& mutex)
| Set the mutex used by the task.
bool | start ()
| Starts task.
bool | stop ()
| Stops task.
## Static Public Member Functions
static Glib::RefPtr<Task> | create (const SlotTask& task_slot)
| Create a new Gst::Task that will repeatedly call the provided slot as a parameter.
static void | cleanup_all ()
| Wait for all tasks to be stopped.
## Protected Member Functions
| Task (const SlotTask& task_slot)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr<Gst::Task> | wrap (GstTask* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Gst::Task - Abstraction of GStreamer streaming threads.

Gst::Task is used by Gst::Element and Gst::Pad to provide the data passing threads in a Gst::Pipeline.

A Gst::Pad will typically start a Gst::Task to push or pull data to/from the peer pads. Most source elements start a Gst::Task to push data. In some cases a demuxer element can start a Gst::Task to pull data from a peer element. This is typically done when the demuxer can perform random access on the upstream peer element for improved performance.

Although convenience functions exist on Gst::Pad to start/pause/stop tasks, it might sometimes be needed to create a Gst::Task manually if it is not related to a Gst::Pad.

Before the Gst::Task can be run, it needs a Glib::StaticRecMutex that can be set with set_lock().

The task can be started, paused and stopped with start(), pause() and stop() respectively.

A Gst::Task will repeadedly call the Gst::Task::SlotTask that was provided when creating the task with create(). Before calling the function it will acquire the provided lock.

Stopping a task with stop() will not immediatly make sure the task is not running anymore. Use join() to make sure the task is completely stopped and the thread is stopped.

Last reviewed on 2006-02-13 (0.10.4)

## Member Typedef Documentation

typedef sigc::slot<void> Gst::Task::SlotTask

For example, void on_do_task();.

## Constructor & Destructor Documentation

virtual Gst::Task::~Task | ( |  | ) | `[virtual]`

Gst::Task::Task | ( | const SlotTask& | task_slot | ) | `[protected]`

## Member Function Documentation

static void Gst::Task::cleanup_all | ( |  | ) | `[static]`

Wait for all tasks to be stopped.

This is mainly used internally to ensure proper cleanup of internal data structures in test suites.

MT safe.

static Glib::RefPtr<Task> Gst::Task::create | ( | const SlotTask& | task_slot | ) | `[static]`

Create a new Gst::Task that will repeatedly call the provided slot as a parameter.

Typically the task will run in a new thread.

The slot cannot be changed after the task has been created. You must create a new Gst::Task to change the slot.

Parameters:

  | task_slot | The Gst::Task::SlotTask to use.

Returns:
  A new Gst::Task. MT safe.

TaskState Gst::Task::get_state | ( |  | ) | const

Get the current state of the task.

Returns:
  The Gst::TaskState of the task

MT safe.

const GstTask* Gst::Task::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gst::Object.

GstTask* Gst::Task::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gst::Object.

GstTask* Gst::Task::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gst::Object.

bool Gst::Task::join | ( |  | ) |

Joins task.

After this call, it is safe to unref the task and clean up the lock set with set_lock().

The task will automatically be stopped with this call.

This function cannot be called from within a task function as this would cause a deadlock. The function will detect this and print a g_warning.

Returns:
  `true` if the task could be joined.

MT safe.

bool Gst::Task::pause | ( |  | ) |

Pauses task.

This method can also be called on a task in the stopped state, in which case a thread will be started and will remain in the paused state. This function does not wait for the task to complete the paused state.

Returns:
  `true` if the task could be paused.

MT safe.

void Gst::Task::set_lock | ( | Glib::StaticRecMutex & | mutex | ) |

Set the mutex used by the task.

The mutex will be acquired before calling the Gst::TaskFunction.

This function has to be called before calling pause() or start().

MT safe.

Parameters:

  | mutex | The Mutex to use.

bool Gst::Task::start | ( |  | ) |

Starts task.

The task must have a lock associated with it using set_lock() or this function will return `false`.

Returns:
  `true` if the task could be started.

MT safe.

bool Gst::Task::stop | ( |  | ) |

Stops task.

This method merely schedules the task to stop and will not wait for the task to have completely stopped. Use join() to stop and wait for completion.

Returns:
  `true` if the task could be stopped.

MT safe.

## Friends And Related Function Documentation

Glib::RefPtr<Gst::Task> wrap | ( | GstTask * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- task.h